# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import os
import playerlib
import keyvalues
import popuplib
import cmdlib
# ============================================================================================================================================================= #

# * SAM IMPORTS

func = es.import_addon('sam/functions')

# * VARIABLES

db     = 'sam_admins'
db_dir = 'cstrike/cfg/sam/databases/es_sam_admins_db.txt'
access = [
		'Admins Manager',
		'Addons Manager',
		'Kick',
		'Ban Level 1',
		'Ban Level 2',
		'Unban',
		'Move Players',
		'Slay',
		'Mute',
		'Server Commands',
		'Remote RCON',
		'Advance Control',
		'Admin Chat'
		]

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Temp Vars ###
	es.set('sam_first_admin', 0)

	### Load Keygroups ###
	if os.path.isfile(db_dir) == True: es.keygroupload(db, func.dbfiles)

	### CMDS ###
	cmdlib.registerSayCommand('!addadmin', addAdminCMD, 'SAM')
	cmdlib.registerClientCommand('sam_addadmin', addAdminCMD, 'SAM')

	### Update Admins ###
	if checkDB:
		for ply in playerlib.getPlayerList('#human'):
			if isAdmin(ply.steamid): updateAdmin(ply.steamid)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Deletes ###
	if es.exists('keygroup', db) == 1: es.keygroupdelete(db)

	### CMDS ###
	cmdlib.unregisterSayCommand('!addadmin')
	cmdlib.unregisterClientCommand('sam_addadmin')

	### Popups ###
	func.popupDelete('firstAdmin')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def addAdminCMD(userid, args):
	if isAdmin(es.getplayersteamid(userid)):
		if checkAccess(es.getplayersteamid(userid), 'Admins Manager'):
			if args:
				string = ''.join(args)
				if string.startswith('STEAM_'):
					if not isAdmin(string):
						if checkDB() == False: es.keygroupcreate(db)
						es.keycreate(db, string)
						es.keysetvalue(db, string, 'immunity', 0)
						es.keysetvalue(db, string, 'name', string)
						for item in access: es.keysetvalue(db, string, item, 'yes')
						es.keygroupsave(db, func.dbfiles)
						block = es.import_addon('sam/base/manager')
						block.editChoice(userid, string, None)
					else: func.hudhint(userid, func.lang_admins('is_admin', {'admin':string}), func.admins_hudtag)
				elif es.exists('userid', es.getuserid(string)):
					target = es.getplayersteamid(es.getuserid(string))
					if not isAdmin(target):
						addAdmin(target)
						block = es.import_addon('sam/base/manager')
						block.editChoice(userid, target, None)
					else: func.hudhint(userid, func.lang_admins('is_admin', {'admin':es.getplayername(es.getuserid(string))}), func.admins_hudtag)
			else:
				block = es.import_addon('sam/base/manager')
				block.managerChoice(userid, 1, None)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def isAdmin(target):
	if checkDB():
		if es.exists('key', db, target): return True
		else: return False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getAdmin(target):
	if isAdmin(target):
		admin = {'steamid':target,'immunity':es.keygetvalue(db, target, 'immunity'),'name':es.keygetvalue(db, target, 'name')}
		for item in access: admin[item] = es.keygetvalue(db, target, item)
		return admin
	else: return False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def checkAccess(target, item):
	if isAdmin(target):
		admin  = getAdmin(target)
		access = 0
		if item == 'Ban':
			if admin['Ban Level 1'] == 'yes' or admin['Ban Level 2'] == 'yes': access = 1
		elif admin[item] == 'yes': access = 1
		if access == 1: return True
		else:
			func.hudhint(es.getuserid(target), func.lang_admins('no_access'), func.admins_hudtag)
			return False
	else:
		func.hudhint(es.getuserid(target), func.lang_admins('no_access'), func.admins_hudtag)
		return False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def checkImmunity(admin, target):
	if not admin == None:
		if isAdmin(target):
			adminIM  = getAdmin(admin)
			targetIM = getAdmin(target)
			if int(adminIM['immunity']) > int(targetIM['immunity']): return True
			elif int(adminIM['immunity']) <= int(targetIM['immunity']):
				if int(adminIM['immunity']) > 0:
					func.hudhint(es.getuserid(admin), func.lang_admins('lower_immunity'), func.admins_hudtag)
					return False
				else: return True
		else: return True
	else: return True

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def addAdmin(target):
	if checkDB() == False: es.keygroupcreate(db)
	admin = playerlib.getPlayer(es.getuserid(target))
	es.keycreate(db, admin.steamid)
	es.keysetvalue(db, admin.steamid, 'immunity', 0)
	es.keysetvalue(db, admin.steamid, 'name', admin.name)
	for item in access: es.keysetvalue(db, admin.steamid, item, 'yes')
	es.keygroupsave(db, func.dbfiles)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def removeAdmin(userid, target):
	if isAdmin(target):
		admins = 0
		for admin in keyvalues.getKeyGroup(db): admins += 1
		if admins > 1:
			es.keydelete(db, target)
			es.keygroupsave(db, func.dbfiles)
		else: func.hudhint(userid, func.lang_admins('need_one_admin'), func.admins_hudtag)
	else: func.hudhint(userid, func.lang_admins('not_admin'), func.admins_hudtag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def checkDB():
	if os.path.isfile(db_dir) != True:
		es.set('sam_first_admin', 1)
		return False
	elif es.exists('keygroup', db) != 1:
		es.set('sam_first_admin', 1)
		return False
	else: return True

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def updateAdmin(admin):
	admin = playerlib.getPlayer(es.getuserid(admin))
	es.keysetvalue(db, admin.steamid, 'name', admin.name)
	for item in access:
		if not es.exists('keyvalue', db, admin.steamid, item): es.keysetvalue(db, admin.steamid, item, 'yes')
	es.keygroupsave(db, func.dbfiles)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def chatFilter(userid, text, teamonly):
	var = es.ServerVar('sayfilter_%s' % (userid))
	if int(es.ServerVar('sayfilter_%s' % (userid))) == 1:
		text = text.strip('"')
		es.set('sayfilter_%s' % (userid), 0)
		if str(text) == es.ServerVar('rcon_password'):
			addAdmin(userid)
			block = es.import_addon('sam/base')
			block.displayMenu(userid)
			block = es.import_addon('sam/base/manager')
			block.modulePopup(userid)
			es.set('sam_first_admin', 0)
			block.editChoice(userid, es.getplayersteamid(userid), None)
		else: func.tell(userid, '#grey' + func.lang_admins('invalid_rcon', {'text':str(text)}), func.servertag)
		es.addons.unregisterSayFilter(chatFilter)
		return (0, 0, 0)
	else: return (userid, text, teamonly)

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def player_activate(ev):
	if checkDB: updateAdmin(ev['es_steamid'])

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def player_changename(ev):
	if checkDB: updateAdmin(ev['es_steamid'])

# ============================================================================================================================================================= #
# ========================================================================= BLOCKS ============================================================================ #
# ============================================================================================================================================================= #
def firstAdmin(userid):
	target = playerlib.getPlayer(userid)
	func.popupDelete('firstAdmin')
	popup = popuplib.create('firstAdmin')
	popup.addline('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
	popup.addline('\n \n :: ' + func.lang_titles('manager_name'))
	popup.addline(func.pline + '-' * 15)
	popup.addline(' %s\n' % func.lang_admins('firstAdmin_line1'))
	popup.addline(' %s\n \n' % func.lang_admins('firstAdmin_line2'))
	popup.addline(func.lang_admins('firstAdmin_line3'))
	popup.addline('->1. ' + func.lang_word('yes'))
	popup.addline('->2. ' + func.lang_word('no'))
	popup.addline(' ')
	popup.addline(func.pline + '-' * 15)
	popup.addline('0. ' + func.lang_word('cancel'))
	popup.menuselect = firstPageSelect
	popup.send(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def firstPageSelect(userid, choice, popup):
	if choice == 1:
		es.set('sayfilter_%s' % (userid), 1)
		es.addons.registerSayFilter(chatFilter)
		func.tell(userid, '#grey' + func.lang_admins('rcon_confirmation'), func.adminstag)

# ============================================================================================================================================================= #