# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import gamethread
import os
import playerlib
import popuplib
import cmdlib
import langlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

es.set('sam_mapchange_re', 'none')

# '''''''''''''''''''' # Addon/Mod Info # '''''''''''''''''' #
addon = es.AddonInfo()
addon.name     = 'Map Change'
addon.basename = 'mapchange'
addon.desc     = func.lang_addonsDesc(addon.basename)
addon.version  = '1.0.p'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	''' Addon State '''
	es.set('sam_' + addon.basename, 1)

	''' Change Map CMD '''
	cmdlib.registerSayCommand('!changemap', changemapCMD, 'SAM')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	''' Addon State '''
	es.set('sam_' + addon.basename, 0)

	''' Unreg CMDs '''
	cmdlib.unregisterSayCommand('!changemap')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def changemapCMD(userid, args):
	if args:
		maplist = getMapList()
		name    = ' '.join(args)
		if name in maplist:
			func.hudhint('#human', langFilter('changing_to_map', {'map':name}))
			gamethread.delayed(3, es.server.queuecmd, ('changelevel %s' % name))
		else: func.tell(userid, langFilter('map_not_listed', {'map':name}), func.servertag)
	else: modulePopup(userid)

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def modulePopup(userid):
	func.popupDelete('mapChange')
	popup = popuplib.easymenu('mapChange', None , mapChangeChoice)
	popup.c_beginsep = pline = '-' * 45
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
	popup.setdescription('\n \n :: ' + func.lang_titles('mapchange_maplist_desc'))
	for item in getMapList(): popup.addoption(item, item)
	popup.submenu(10, 'mainPage')
	popuplib.send('mapChange', userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def mapChangeChoice(userid, choice, popup):
	func.popupDelete('time_to_change')
	popup = popuplib.easymenu('time_to_change', None , changeMap)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
	popup.setdescription('\n \n :: ' + func.lang_titles('mapchange_whentochange_desc'))
	popup.addoption({'id':1,'map':choice}, langFilter('change_map_now'))
	popup.addoption({'id':2,'map':choice}, langFilter('change_map_roundend'))
	popup.submenu(10, 'mainPage')
	popuplib.send('time_to_change', userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def changeMap(userid, choice, popup):
	if choice['id'] == 1:
		func.hudhint('#human', langFilter('changing_to_map', {'map':choice['map']}))
		gamethread.delayed(3, es.server.queuecmd, ('changelevel %s' % choice['map']))
	else:
		for ply in es.getUseridList(): func.tell(ply, langFilter('changing_map_roundend', {'map':choice['map']}), func.servertag)
		es.set('sam_mapchange_re', choice['map'])

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getMapList():
	maplist = []
	dir     = 'cstrike/maps'
	list    = os.listdir(dir)
	for item in list:
		if os.path.isdir(dir + '/' + item) == False:
			type = item.split('.')
			length = len(type) - 1
			if type[length] == 'bsp':
				map = item[0:len(item) - 4]
				maplist.append(map)
	return maplist

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def round_end(ev):
	var = es.ServerVar('sam_mapchange_re')
	if not var == 'none':
		func.hudhint('#all', langFilter('changing_to_map', {'map':var}))
		gamethread.delayed(3, es.server.queuecmd, ('changelevel %s' % var))
		es.set('sam_mapchange_re', 'none')

# ============================================================================================================================================================= #
# ========================================================================= BLOCKS ============================================================================ #
# ============================================================================================================================================================= #
def langFilter(text, tokens = None): return func.lang_addon(addon.basename, text, tokens)

# ============================================================================================================================================================= #