# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import os
import popuplib
import playerlib
import langlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

Global = ['Kick','Ban']
Others = ['Unban','Mute','Move Players','Respawn','Freeze','Noclip','Godmode']
Alive  = ['Slay']
Dead   = []

adv    = ['Respawn','Noclip','Freeze','Godmode']

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Loads ###
	for x in (Global, Alive, Others, Dead):
		for item in x:
			if not item in adv: es.load('sam/base/pcontrol/' + item.replace(' ','').lower())
	es.load('sam/base/pcontrol/couples')
	es.load('sam/base/pcontrol/respawn')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Unloads ###
	for x in (Global, Alive, Others, Dead):
		for item in x:
			if not item in adv: es.unload('sam/base/pcontrol/' + item.replace(' ','').lower())
	es.unload('sam/base/pcontrol/couples')
	es.unload('sam/base/pcontrol/respawn')

	### Popups ###
	func.popupDelete('pcontrol')
	func.popupDelete('pcontrol_getTarget')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def modulePopup(userid):
	func.popupDelete('pcontrol')
	popup = popuplib.easymenu('pcontrol', None, pcontrol_Choice)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
	popup.setdescription('\n \n :: ' + func.lang_titles('pcontrol_name'))
	for x in (Global, Alive, Others, Dead):
		for item in x: popup.addoption(item, item)
	popup.submenu(10, 'mainPage')
	popup.send(userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def pcontrol_Choice(userid, choice, popup):
	if choice in adv:
		if admins.checkAccess(es.getplayersteamid(userid), 'Advance Control'): pass
		else: choice = None
	elif admins.checkAccess(es.getplayersteamid(userid), choice): pass
	else: choice = None

	if choice != None:
		if choice in Others: sendTo_Others(userid, choice, None)
		else:
			func.popupDelete('pcontrol_getTarget')
			popup = popuplib.easymenu('pcontrol_getTarget', None, sendTo_Module)
			popup.c_beginsep = func.pline
			popup.c_pagesep  = func.pline
			popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
			popup.setdescription('\n \n :: %s\n# %s' % (func.lang_titles('pcontrol_%s' % choice.replace(' ','').lower()), func.lang_titles('pcontrol_%s_desc' % choice.replace(' ','').lower())))
			popup.submenu(10, 'pcontrol')
			if choice in Global:
				for player in playerlib.getPlayerList('#human'): popup.addoption({'choice':choice.replace(' ','').lower(), 'target':player}, player.name)
				popup.send(userid)
			elif choice in Alive:
				alive = playerlib.getPlayerList('#alive')
				if len(alive) > 0:
					for player in alive: popup.addoption({'choice':choice.replace(' ','').lower(), 'target':player}, player.name)
					popup.send(userid)
				else: 
					func.hudhint(userid, func.lang_pcontrol('no_alive_players'))
					modulePopup(userid)
			elif choice in Dead:
				dead = playerlib.getPlayerList('#dead')
				if len(dead) > 0:
					for player in dead: popup.addoption({'choice':choice.replace(' ','').lower(), 'target':player}, player.name)
					popup.send(userid)
				else: 
					func.hudhint(userid, func.lang_pcontrol('no_dead_players'))
					modulePopup(userid)
			else: modulePopup(userid)
	else: modulePopup(userid)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def sendTo_Module(userid, choice, popup):
	admin  = playerlib.getPlayer(userid)
	target = playerlib.getPlayer(choice['target'])
	block  = es.import_addon('sam/base/pcontrol/' + choice['choice'])
	block.moduleAction(admin,target)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def sendTo_Others(userid, choice, popup):
	if not choice in adv:
		block = es.import_addon('sam/base/pcontrol/' + choice.replace(' ','').lower())
		block.moduleAction(userid)
	else:
		if choice != 'Respawn':
			block = es.import_addon('sam/base/pcontrol/couples')
			block.moduleAction(userid, choice.replace(' ','').lower())
		else:
			block = es.import_addon('sam/base/pcontrol/' + choice.replace(' ','').lower())
			block.moduleAction(userid)

# ============================================================================================================================================================= #